#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdbool.h>

struct taskas {
    float x, y;
};

void rikiuok(float mas[], int ilg) {
    int i, j, maxi;
    float max, buf;
    for (i = 0; i <= ilg; i++) {
        max = mas[i];
        maxi = i;
        for (j = i + 1; j <= ilg; j++) {
            if (max < mas[j]) {
                max = mas[j];
                maxi = j;
            }
        }
        buf = max;
        mas[maxi] = mas[i];
        mas[i] = buf;
    }
}

float ilgis(struct taskas a, struct taskas b) {
    return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

bool eq(float a, float b) {
    if (fabs(a - b) < 0.0001) {
        return true;
    }
    else {
        return false;
    }
}

int main() {
    int i, j, k, l, maxi, maxj, mini, minj;
    struct taskas mas[9];
    bool task[9];
    float maxilg, minilg, ilg[5];
    bool rasta;

    printf("Iveskite 10 tasku.\nPrograma suras visus imanomus kvadratus, kuriu virsunes yra bet kurie 4 taskai is ivestu tasku.\n");
    for (i = 0; i < 10; i++) {
        scanf("%f %f", &mas[i].x, &mas[i].y);
    }

    for (i = 0; i <= 9; i++) {
        task[i] = false;
    }
    maxilg = 0;
    minilg = 0;
    rasta = false;

    for (i = 0; i < 7; i++) {
        for (j = i + 1; j < 8; j++) {
            for (k = j + 1; k < 9; k++) {
                for (l = k + 1; l < 10; l++) {
                    ilg[0] = ilgis(mas[i], mas[j]);
                    ilg[1] = ilgis(mas[i], mas[k]);
                    ilg[2] = ilgis(mas[i], mas[l]);
                    ilg[3] = ilgis(mas[j], mas[k]);
                    ilg[4] = ilgis(mas[j], mas[l]);
                    ilg[5] = ilgis(mas[k], mas[l]);
                    rikiuok(ilg, 5);
                    if (eq(ilg[0], ilg[1]) && eq(ilg[2], ilg[3]) && eq(ilg[2], ilg[4]) && eq(ilg[2], ilg[5])) {
                        if (ilg[0] == 0 || ilg[2] == 0) {
                            continue;
                        }
                        rasta = true;
                        printf("Kvadratas: (%.3f;%.3f) (%.3f;%.3f) (%.3f;%.3f) (%.3f;%.3f)\n",
                               mas[i].x, mas[i].y, mas[j].x, mas[j].y, mas[k].x, mas[k].y, mas[l].x, mas[l].y);
                        task[i] = true;
                        task[j] = true;
                        task[k] = true;
                        task[l] = true;
                    }
                }
            }
        }
    }

    if (rasta) {
        for (i = 0; i <= 9; i++) {
            for (j = i + 1; j <= 9; j++) {
                if (!task[i] || !task[j]) {
                    continue;
                }
                if (ilgis(mas[i], mas[j]) > maxilg) {
                    maxilg = ilgis(mas[i], mas[j]);
                    maxi = i;
                    maxj = j;
                }
                if (ilgis(mas[i], mas[j]) > maxilg || minilg == 0) {
                    minilg = ilgis(mas[i], mas[j]);
                    mini = i;
                    minj = j;
                }
            }
        }
        printf("Didziausias atstumas tarp kvadratu tasku: (%.3f;%.3f) (%.3f;%.3f)\n", mas[maxi].x, mas[maxi].y, mas[maxj].x, mas[maxj].y);
        printf("Maziausias atstumas tarp kvadratu tasku:  (%.3f;%.3f) (%.3f;%.3f)\n", mas[mini].x, mas[mini].y, mas[minj].x, mas[minj].y);
    }
    else {
        printf("Kvadratu nerasta");
    }

    system("PAUSE");
    return 0;
}
